progname=exercise_06_31
CC=g++
CFLAGS=-Wall -Wextra -Werror -g3

all: test1 test2 test3

debug/$(progname): debug/$(progname).o
	$(CC) $(CFLAGS)  $<  -o  $@

debug/%.o: debug/%.s
	$(CC) -c $(CFLAGS) $<  -o $@

debug/%.s: debug/%.ii
	$(CC) -S $(CFLAGS) $<  -o $@

debug/%.ii: %.cpp | debug
	$(CC) -E  $(CFLAGS)  $<  -o $@

debug:
	mkdir -p debug

clean:
	rm -r debug *.out 

test%: debug/$(progname) 
	./debug/$(progname) < $@.in > $@.out || echo "$@ is executing..."
	diff $@.out $@.expected && echo PASSED || echo FAILED

.PRECIOUS: debug/%.ii  debug/%.s
.SECONDARY: debug/%.ii  debug/%.s

